/*
    pcb-rnd-3dview - watch a file for changes and run a viewer bg-process
    Copyright (C) 2021  Tibor 'Igor2' Palinkas

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Project page: http://www.repo.hu/projects/pcb-rnd-3dview
    VCS: svn://svn.repo.hu/pcb-rnd-3dview/trunk
    Contact: http://igor2.repo.hu/contact.html
*/

/* External viewer: projector(1) */

typedef struct {
	double ax, az, zoom;
	double ocx, ocy, ocz;

	double pressx, pressy, pressax, pressay, pressaz, pressocx, pressocy, pressocz, motx, moty;
	int press;

	int prj_wfd, prj_rfd;
	FILE *prj_wf, *prj_rf;
} projview_t;

void projview_init(projview_t *ctx);

/* Load a projector script from fn and install scene */
int projview_load_file(projview_t *ctx, const char *fn);

/* Load a projector script from the stdout of cmd and install scene */
int projview_load_proc(projview_t *ctx, const char *cmd);

/* Set up camera and lighting */
int projview_cam(projview_t *ctx);

/* Run UI timer - call this periodically */
int projview_tick(projview_t *ctx);

/* Call this when ctx->prj_rfd is readable */
void projview_read(projview_t *ctx);

